#include <stdio.h>
#include <stdlib.h>
#include "bergenListener.h"
#include "bergenServer.h"
#include "bergenTone.h"


// Creates the tone sound object 
bergenTone::bergenTone(bergenServer *server) : bergenSound(server)
	{
	createRemote();
	}


// Creates new Tone Objekt by sending a message to the server to create it 
void bergenTone::createRemote(void)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "server" ) << "tone" << server_->listener()->handle() << osc::EndMessage;	
		server_->sendMessage( p );
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Sets the frequency of the sound to be freq cycles per second. The default
// frequency is 1000 Hz.
void bergenTone::setFrequency(float freq)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "object" ) << handle_ << "frequency" << freq << osc::EndMessage;	
		server_->sendMessage( p );
		}
	}

