#include <stdio.h>
#include <stdlib.h>
#include "bergenListener.h"
#include "bergenServer.h"
#include "bergenWhiteNoise.h"


// Creates the white-noise sound object. 
bergenWhiteNoise::bergenWhiteNoise(bergenServer *server) : bergenSound(server)
	{
	createRemote();
	}


// Creates new White Noise Objekt by sending a message to the server to create it
void bergenWhiteNoise::createRemote(void)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "server" ) << "whitenoise" << server_->listener()->handle() << osc::EndMessage;	
		server_->sendMessage( p );
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}
